import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import Component from './base/component';
import Children from './children';

var Timeline = /*#__PURE__*/function (_Component) {
  _inherits(Timeline, _Component);

  var _super = _createSuper(Timeline);

  function Timeline(props) {
    var _this;

    _classCallCheck(this, Timeline);

    _this = _super.call(this, props);
    var delay = props.delay,
        _props$start = props.start,
        start = _props$start === void 0 ? 0 : _props$start,
        children = props.children;
    var count = Children.toArray(children).length;
    _this.state = {
      delay: delay,
      count: count,
      index: start
    };
    return _this;
  }

  _createClass(Timeline, [{
    key: "next",
    value: function next() {
      var _this2 = this;

      var state = this.state,
          props = this.props;
      var index = state.index,
          count = state.count,
          delay = state.delay;
      var loop = props.loop;
      var next = loop ? (index + 1) % count : index + 1;

      if (next < count) {
        setTimeout(function () {
          _this2.setState({
            index: next
          });
        }, delay || 0);
        return true;
      }

      return false;
    }
  }, {
    key: "render",
    value: function render() {
      var state = this.state,
          props = this.props;
      var children = props.children;
      var index = state.index;
      var childrenArray = Children.toArray(children);
      return childrenArray[index];
    }
  }], [{
    key: "find",
    value: function find(children) {
      if (!children) return null;
      var elements = Children.toArray(children);

      for (var i = 0, len = elements.length; i < len; i++) {
        var element = elements[i];

        if (element && element.component && element.component.constructor === Timeline) {
          return element.component;
        }
      }
    }
  }]);

  return Timeline;
}(Component);

export default Timeline;